#![doc = include_str!("../README.md")]
#![deny(unsafe_code)]
#![feature(doc_auto_cfg)]

mod context;
pub use context::{Context, IntoContext};

mod report;
pub use report::{Report, ReportOpts};

mod explain;
pub use explain::Explain;

#[cfg(feature = "termination")]
mod termination;
#[cfg(feature = "termination")]
pub use termination::TerminationResult;

mod how;
pub use self::how::How;

pub type Result<T, E = How> = std::result::Result<T, E>;

#[cfg(test)]
mod test;
